//-------------------------------------------------------------
// File: main.h
//
// Desc: [Vu[
//-------------------------------------------------------------
#pragma once



//-------------------------------------------------------------
// `萔
//-------------------------------------------------------------
// ݂̓̓f[^ۑ\
struct UserInput
{
    BOOL bRotateUp;
    BOOL bRotateDown;
    BOOL bRotateLeft;
    BOOL bRotateRight;
    BOOL bZoomIn;
    BOOL bZoomOut;
	BOOL bDispersionUp;
	BOOL bDispersionDown;
};




//-------------------------------------------------------------
// Name: class CMyD3DApplication
// Desc: AvP[ṼNX
//-------------------------------------------------------------
class CMyD3DApplication : public CD3DApplication
{
	CD3DMesh				*m_pMesh;
	CD3DMesh				*m_pMeshBg;
			
	// _OeNX`
	LPDIRECT3DSURFACE9		m_pZBg;			// [xobt@
	LPDIRECT3DTEXTURE9		m_pTexBg;		// eNX`
	LPDIRECT3DSURFACE9		m_pSurfBg;		// T[tFX
	LPDIRECT3DSURFACE9		m_pZObj;		// [xobt@
	LPDIRECT3DTEXTURE9		m_pTexObj;		// eNX`
	LPDIRECT3DSURFACE9		m_pSurfObj;		// T[tFX

	// VF[_
	LPD3DXEFFECT		    m_pEffect;		// GtFNg
	D3DXHANDLE				m_hTechnique;	// eNjbN
	D3DXHANDLE				m_hmWV;			// [J-r[ϊs
	D3DXHANDLE				m_hmVP;			// r[-ˉeϊs
	D3DXHANDLE				m_hmLastWV;		// PO̕ϊs
	D3DXHANDLE				m_hvLightDir;	// Cg̕
	D3DXHANDLE				m_hvEyePos;		// _
	D3DXHANDLE				m_hvCol;		// _F
	D3DXHANDLE				m_htSrcMap;		// eNX`
	
	// ʏ̍Wϊs
	D3DXMATRIX				m_mWorld;
	D3DXMATRIX				m_mView;
	D3DXMATRIX				m_mProj;
	D3DXMATRIX				m_mLastWV;

	BOOL					m_bLoadingApp;	// [hH
    CD3DFont*				m_pFont;		// tHg
    UserInput				m_UserInput;	// ̓f[^

    FLOAT                   m_fWorldRotX;   // w]
    FLOAT                   m_fWorldRotY;   // x]
    FLOAT                   m_fViewZoom;    // _̋

protected:
    virtual HRESULT OneTimeSceneInit();
    virtual HRESULT InitDeviceObjects();
    virtual HRESULT RestoreDeviceObjects();
    virtual HRESULT InvalidateDeviceObjects();
    virtual HRESULT DeleteDeviceObjects();
    virtual HRESULT Render();
    virtual HRESULT FrameMove();
    virtual HRESULT FinalCleanup();
    virtual HRESULT ConfirmDevice( D3DCAPS9*, DWORD, D3DFORMAT );

    HRESULT RenderText();

    void    UpdateInput( UserInput* pUserInput );
public:
    LRESULT MsgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
    CMyD3DApplication();
    virtual ~CMyD3DApplication();
};

